<template>
  <q-dialog v-model="persistent" content-class="bg-grey-1" persistent transition-show="scale" transition-hide="scale">
    <q-card style="width: 800px;max-width:900px;">
      <q-card-section>
        <div class="text-h6">{{objOption.Id==0?'新增网站新闻类型':'修改网站新闻类型'}}</div>
      </q-card-section>
      <q-card-section class="q-pt-none scroll" style="max-height: 70vh">
        <div class="text-caption q-mb-lg q-px-md text-grey-6">网站新闻类型</div>
        <div class="row wrap" style="align-items:end;">
          <q-input filled stack-label style="float:left;" maxlength="20" :dense="false" v-model="objOption.TypeName" ref="TypeName"
            class="col-6 q-pr-lg q-pb-lg" label="新闻类型" :rules="[val => !!val || '请填写类型名称']" />
          <div class="col-6 q-pb-lg q-pr-lg">
            <q-uploader :style="{ backgroundImage: 'url(' + objOption.Image + ')' }" style="width:auto;height:200px;background-repeat:no-repeat;background-size:cover;" flat
              hide-upload-btn max-files="1" label="类型图片" accept=".jpg, image/*" :factory="uploadFile" auto-upload>
            </q-uploader>
          </div>
        </div>
      </q-card-section>
      <q-separator />
      <q-card-actions align="right" class="bg-white">
        <q-btn label="取消" flat color="grey-10" style="font-weight:400 !important" @click="closeSaveForm" />
        <q-btn label="立即提交" color="accent q-px-md" style="font-weight:400 !important" :loading="saveLoading"
          @click="saveWebkitMenu" />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script>
  import {
    SetWebNewsType,
    GetWebNewsType
  } from '../../api/system/webkit'
  import {
    UploadSelfFile
  } from "../../api/common/common";
  export default {
    props: {
      saveObj: {
        type: Object,
        default: null
      }
    },
    data() {
      return {
        persistent: true,
        objOption: {
          Id: 0,
          TypeName: '', //类型名称
          Image: '',
        },
        optionTitle: "",
        saveLoading: false,
      }
    },
    mounted() {
      this.initObj()
    },
    methods: {
      uploadFile(files) {
        UploadSelfFile("course", files[0], res => {
          if (res.Code == 1) {
            this.objOption.Image = res.FileUrl;
          }
        });
      },
      //初始化表单
      initObj() {
        if (this.saveObj && this.saveObj.Id > 0) {
          GetWebNewsType({
            Id: this.saveObj.Id
          }).then(res => {
            this.objOption.Id = res.Data.Id;
            this.objOption.TypeName = res.Data.TypeName;
            this.objOption.Image = res.Data.Image;
          })
          this.optionTitle = "修改新闻类型信息"
        } else {
          this.optionTitle = "新增新闻类型信息"
          this.objOption.Id = 0;
          this.objOption.TypeName = '';
          this.objOption.Image = '';
        }
      },
      //关闭弹窗
      closeSaveForm() {
        this.$emit('close')
        this.persistent = false
      },
      //保存菜单
      saveWebkitMenu() {
        this.$refs.TypeName.validate();
        if (!this.$refs.TypeName.hasError) {
          this.saveLoading = true
          SetWebNewsType(this.objOption).then(res => {
            this.saveLoading = false
            this.$q.notify({
              icon: 'iconfont icon-chenggong',
              color: 'accent',
              timeout: 2000,
              message: '数据保存成功！',
              position: 'top'
            })
            this.$emit("success")
            this.closeSaveForm()
          }).catch(() => {
            this.saveLoading = false
          })
        }
      }
    },
  }

</script>
